#include "mplayer.h"
#include <device/sound.h>

//¹ԤȽä㤦ΤǤȤ
#define FATAL_ERROR(msg) { printf("Fatal error at line %s in file %d: %s\n",  (__FILE__), (__LINE__), (msg)); exit(1);    }

// audioǡrea_recΥեå
W aoffset;
// ץοץ󥰥졼
int totalsamples = 0;
int samplerate = 0;
// inputλƤ뤫ɤɽ
static int mad_input_finish = 0;

// soundǥХ
W         soundDeviceID = -1;
static TC	 soundDeviceName[] = { TK_s, TK_o, TK_u, TK_n, TK_d, TNULL };
#define          OUTPUT_BUFFER_SIZE 8192
static B         outputBuffer[OUTPUT_BUFFER_SIZE];
static W         outputBufferBytes;
static SDPcmMode soundDeviceMode;
static W         soundDeviceBufferSize = 65536;
static const W   soundDeviceStopCount = 0x7fffffff;
static BOOL      isSoundDeviceModeSet = FALSE;
static BOOL      isAudioInfoSent = FALSE;
//static W         pauseEventFlagID = -1;

// 48000MHz -> 44100MHz 󥵥ץ
// 48000 = 300 * 160, 44100 = 300 * 147 ʤΤǡ
// Ѵơ֥Υ160˸
// Υ롼ϤägenericʤΤѹǽ
static BOOL    isDS48KOn = FALSE;
static W       DS48KOriginalSamples;
static const W DS48KOriginalSamplesMax = 160;
static const W DS48KConvertedSamplesMax = 147;
static W       DS48KOriginalSampleBufferLeft[160];
static W       DS48KOriginalSampleBufferRight[160];
static W       DS48K1stOriginalSampleIndexTable[147];
static W       DS48K1stOriginalSampleWeightTable[147];
static W       DS48KWeightMax;

static W       previousAudioStreamBufferSize = 0;

// ϥǥХ
int 	    OpenOutputSoundDevice();
void        CloseOutputSoundDevice();
static W    SetSoundDeviceMode(int channels, unsigned int sampleRate);
static void ReadFromSoundDevice(W dataNo, B *buffer, W size);
static void WriteToSoundDevice(W dataNo, B *buffer, W size);
static void FlushOutputBuffer(void);
static W    GetAvailableBufferForSoundOutput();

static signed int Scale16(mad_fixed_t sample);
static signed int Scale8(mad_fixed_t sample);

static void InitializeDS48KConversionTable();
static void FlushDS48KOriginalSampleBuffer();

inline void PutByte(UB byteData)
{
    if (outputBufferBytes >= OUTPUT_BUFFER_SIZE) {
          FlushOutputBuffer();
    }
    outputBuffer[outputBufferBytes++] = byteData;
}


struct buffer {
    unsigned char const *start;
    unsigned long length;
};

//ݡȤˤȤޤ褦˥Хåե򾯤ʤˤȤäƤߤ
#define AUDIO_BUFFER_SIZE 4096
uint8_t read_audio_buffer[AUDIO_BUFFER_SIZE + 100];
uint8_t *prev_audio_buffer = NULL;
uint8_t *audio_buffer = NULL;
int prev_audio_buffer_size = 0;

static
enum mad_flow input(void *data, struct mad_stream *stream)
{
    struct buffer *buffer = (struct buffer *)data;
    int size, tmpsize, demuxsize;

    if (mad_input_finish == 1) {
        return MAD_FLOW_STOP;
    }

//sprintf(debugstr, "stream %d,%d,%d\n",stream->buffer, stream->bufend, stream->bufend - stream->buffer);
//printdebug(debugfd, debugstr);
    while (1) {
        rea_rec(mpegfd, aoffset, (B *)read_audio_buffer, AUDIO_BUFFER_SIZE, &tmpsize, NULL);
        size = tmpsize;
        if (size > AUDIO_BUFFER_SIZE) {
            size = AUDIO_BUFFER_SIZE;
        }
        if (size <= 0) {
            mad_input_finish = 1;
            return MAD_FLOW_STOP;
        }
        aoffset += size;
        demuxsize = demux2 (read_audio_buffer, read_audio_buffer + size, 0, (mpeg2dec_t *)NULL, DEMUX_AUDIO_MODE, &mad_input_finish);
        if (demuxsize > 0 || mad_input_finish == 1) {
            break;
        }
    }

    int rest;
    rest = 0;
    if (prev_audio_buffer) {
        rest = prev_audio_buffer_size + prev_audio_buffer - stream->next_frame;
    }
    int audio_buffer_size;
    audio_buffer_size = rest + demuxsize;
    audio_buffer = (uint8_t *)malloc(audio_buffer_size + 1);
    if (rest > 0) {
        memcpy(audio_buffer, stream->next_frame, rest);
    }
    memcpy(audio_buffer + rest, read_audio_buffer, demuxsize);

//sprintf(debugstr, "size %d,%d,%d,%d,%d\n",size,aoffset,demuxsize,audio_buffer_size,rest);
//printdebug(debugfd, debugstr);

    buffer->start = audio_buffer;
    buffer->length = audio_buffer_size;

    mad_stream_buffer(stream, buffer->start, buffer->length);

    if (prev_audio_buffer) {
        free(prev_audio_buffer);
    }
    prev_audio_buffer = audio_buffer;
    prev_audio_buffer_size = audio_buffer_size;

    return MAD_FLOW_CONTINUE;
}

static inline
signed int scale(mad_fixed_t sample)
{
    /* round */
    sample += (1L << (MAD_F_FRACBITS - 16));

    /* clip */
    if (sample >= MAD_F_ONE) {
        sample = MAD_F_ONE - 1;
    }
    else if (sample < -MAD_F_ONE) {
        sample = -MAD_F_ONE;
    }

    /* quantize */
    return sample >> (MAD_F_FRACBITS + 1 - 16);
}

static
enum mad_flow output(void *data,
		     struct mad_header const *header,
		     struct mad_pcm *pcm)
{
    W nchannels, nsamples;
    mad_fixed_t const *left_ch, *right_ch;
    W sample;

    /* pcm->samplerate contains the sampling frequency */
    static int first = 0;

    if (first == 0) {
sprintf(debugstr, "channels %d nsamples %d samplerate %d left_ch %d, right_ch %d\n",pcm->channels,pcm->length, pcm->samplerate, pcm->samples[0],pcm->samples[1]);
printdebug(debugfd, debugstr);
        first = 1;
    }
    totalsamples += pcm->length;
    samplerate = pcm->samplerate;

    if (!isSoundDeviceModeSet) {
        if (SetSoundDeviceMode(pcm->channels, pcm->samplerate) < 0) {
            sprintf(debugstr, "This sample rate is not supported: %dHz\n",
	       pcm->samplerate);
            printdebug(debugfd, debugstr);
           return MAD_FLOW_STOP;
        }
    }
    nchannels = pcm->channels;
    nsamples  = pcm->length;
    left_ch   = pcm->samples[0];
    right_ch  = pcm->samples[1];

//sprintf(debugstr, "nsamples %d samplerate %d\n", pcm->length, pcm->samplerate);
//printdebug(debugfd, debugstr);
    // there are five modes of output:
    //   (0) downsampling to signed 16 bit stereo
    //   (1) signed 16 bit stereo
    //   (2) signed 16 bit mono
    //   (3) unsigned 8 bit stereo
    //   (4) unsigned 8 bit mono
    if (isDS48KOn) {
        samplerate = 44100;
        // down sampling from 48000MHz to 44100MHz
        // assumes that the output is 44100MHz 16 bit stereo
        // TODO: make the downsampling routine more generic
        while (nsamples-- > 0) {
            sample = Scale16(*left_ch++);
            if (DS48KOriginalSamples < 0 || DS48KOriginalSamples >= DS48KOriginalSamplesMax) {
                printf("DS48KOriginalSamples = %d\n", DS48KOriginalSamples);
                FATAL_ERROR("array index out of bounds");
            }
            DS48KOriginalSampleBufferLeft[DS48KOriginalSamples] = sample;
            if (nchannels == 2)
                sample = Scale16(*right_ch++);
                if (DS48KOriginalSamples < 0 || DS48KOriginalSamples >= DS48KOriginalSamplesMax) {
                printf("DS48KOriginalSamples = %d\n", DS48KOriginalSamples);
                FATAL_ERROR("array index out of bounds");
            }
            DS48KOriginalSampleBufferRight[DS48KOriginalSamples] = sample;
            if (++DS48KOriginalSamples >= DS48KOriginalSamplesMax)
                FlushDS48KOriginalSampleBuffer();
            }
        }
        else if ((soundDeviceMode.datafmt == 2) && soundDeviceMode.stereo) {
            // signed 16 bits stereo
            while (nsamples-- > 0) {
                // left
                sample = Scale16(*left_ch++);
                PutByte((sample >> 0) & 0xff);
                PutByte((sample >> 8) & 0xff);
      
                // right
                if (nchannels == 2)
                    sample = Scale16(*right_ch++);
                PutByte((sample >> 0) & 0xff);
                PutByte((sample >> 8) & 0xff);
            }
        }
        else if ((soundDeviceMode.datafmt == 2) && !soundDeviceMode.stereo) {
            // 16 bit mono
            while (nsamples-- > 0) {
                // left
                sample = Scale16(*left_ch++);
                if (nchannels == 2) {
                    sample += Scale16(*right_ch++); 
                    sample /= 2;
                }
                PutByte((sample >> 0) & 0xff);
                PutByte((sample >> 8) & 0xff);
            }
        }
        else if ((soundDeviceMode.datafmt == 1) && soundDeviceMode.stereo) {
            // unsigned 8 bit stereo
            while (nsamples-- > 0) {
                // left
                sample = Scale8(*left_ch++);
                PutByte(sample);
      
                // right
                if (nchannels == 2) {
                    sample = Scale8(*right_ch++);
                }
                PutByte(sample);
            }
        }
        else {
            // unsigned 8 bit mono
            while (nsamples-- > 0) {
            // left
            sample = Scale8(*left_ch++);
            if (nchannels == 2) {
                sample += Scale8(*right_ch++); 
                sample >>= 1;
            }
            PutByte(sample);
        }
   }

   return MAD_FLOW_CONTINUE;
}

static
enum mad_flow error(void *data,
		    struct mad_stream *stream,
		    struct mad_frame *frame)
{
    struct buffer *buffer = (struct buffer *)data;

    sprintf(debugstr, "decoding error 0x%04x (%s) at byte offset %u\n",
	  stream->error, mad_stream_errorstr(stream),
	  stream->this_frame - buffer->start);
    printdebug(debugfd, debugstr);

    /* return MAD_FLOW_BREAK here to stop decoding (and propagate an error) */

    return MAD_FLOW_CONTINUE;
}


void audiotest(int audiofd)
{
  struct buffer buffer;
  struct mad_decoder decoder;
  int result;

  /* initialize our private message structure */
  int err, alen;
  UB *buf;

    // Хåեν
    outputBufferBytes = 0;
    isSoundDeviceModeSet = FALSE;
    isAudioInfoSent = FALSE;

    aoffset = 0;
//  err = rea_rec(audiofd, 0, NULL, 0, &alen, NULL);
//sprintf(debugstr, "rea_rec %x %d\n", err, alen);
//printdebug(debugfd, debugstr);
//  if (err < 0) {
//      return;
//  }
//  buf = (UB *)malloc(alen);
//  rea_rec(audiofd, 0, (B *)buf, alen, NULL, NULL);

  
 
//  buffer.start  = buf;
//  buffer.length = alen;
    buffer.start = NULL;
    buffer.length = 0;

  /* configure input, output, and error functions */
sprintf(debugstr, "init1 %d\n", buf);
printdebug(debugfd, debugstr);
  mad_decoder_init(&decoder, &buffer,
		   input, 0 /* header */, 0 /* filter */, output,
		   error, 0 /* message */);
sprintf(debugstr, "init2\n");
printdebug(debugfd, debugstr);
  /* start decoding */

sprintf(debugstr, "dec1\n");
printdebug(debugfd, debugstr);
//   result = mad_decoder_run(&decoder, MAD_DECODER_MODE_SYNC);

   result = mad_decoder_run_init(&decoder);
   if (result == 0) {
       while (1) {
           result = mad_decoder_run_sync(&decoder);
           if (result != 0) {
               break;
           }
       }
       mad_decoder_run_end(&decoder);
   }
   else {
       sprintf(debugstr, "failed to run mad decoder\n");
       printdebug(debugfd, debugstr);
   }

sprintf(debugstr, "dec2 %d\n", result);
printdebug(debugfd, debugstr);
  /* release the decoder */

sprintf(debugstr, "fin1 %d %d\n", totalsamples);
printdebug(debugfd, debugstr);
   mad_decoder_finish(&decoder);
   if (prev_audio_buffer) {
      free(prev_audio_buffer);
   }
sprintf(debugstr, "fin2\n");
printdebug(debugfd, debugstr);
}


void CloseOutputSoundDevice()
{
    cls_dev(soundDeviceID, 0, NULL);

}

int OpenOutputSoundDevice()
{
    W    errorCode;
    W     PCMControl;
    SDSel selector;
    SDVol volumeOn = {0xc000, 0xc000}, volumeOff = {0x0000, 0x0000};

    // ǥХ¾⡼ɤǥץ
    if ((soundDeviceID = errorCode = opn_dev(soundDeviceName, D_UPDATE, NULL)) < 0) {
        //FATAL_ERROR("cannot open the output sound device");
        sprintf(debugstr, "cannot open the output sound device\n");
        printdebug(debugfd, debugstr);
        return 1;
    }
    // Ȥꤢαդ
    PCMControl = PCM_STOP;
    WriteToSoundDevice(DN_SDPCMCTL, (B *)&PCMControl, sizeof(PCMControl));

    // PCMХåե
    WriteToSoundDevice(DN_SDPCMBUFSZ, (B *)&soundDeviceBufferSize, sizeof(W));

    // 쥯
    selector.pcm   = (Bool)1;
    selector.beep  = (Bool)0;
    selector.mic   = (Bool)0;
    selector.line  = (Bool)0;
    selector.cd    = (Bool)0;
    selector.music = (Bool)0;
    selector.aux1  = (Bool)0;
    selector.aux2  = (Bool)0;
    selector.rsv1  = 0;
    WriteToSoundDevice(DN_SDSELOUT, (B *)&selector, sizeof(SDSel));

    // ܥ塼
    WriteToSoundDevice(DN_SDGAININ,    (B *)&volumeOff, sizeof(SDVol));
    WriteToSoundDevice(DN_SDGAINOUT,   (B *)&volumeOn,  sizeof(SDVol));
    WriteToSoundDevice(DN_SDVOLMAIN,   (B *)&volumeOn,  sizeof(SDVol));
    WriteToSoundDevice(DN_SDVOLTREBLE, (B *)&volumeOn,  sizeof(SDVol));
    WriteToSoundDevice(DN_SDVOLBASS,   (B *)&volumeOn,  sizeof(SDVol));
    WriteToSoundDevice(DN_SDVOLPCM,    (B *)&volumeOn,  sizeof(SDVol));
    WriteToSoundDevice(DN_SDVOLBEEP,   (B *)&volumeOff, sizeof(SDVol));
    WriteToSoundDevice(DN_SDVOLMIC,    (B *)&volumeOff, sizeof(SDVol));
    WriteToSoundDevice(DN_SDVOLLINE,   (B *)&volumeOff, sizeof(SDVol));
    WriteToSoundDevice(DN_SDVOLCD,     (B *)&volumeOff, sizeof(SDVol));
    WriteToSoundDevice(DN_SDVOLMUSIC,  (B *)&volumeOff, sizeof(SDVol));
    // PMCΥɥɥ饤ФȤʤ顼ˤʤΤǥȥ
    // WriteToSoundDevice(DN_SDVOLAUX1,   (B *)&volumeOff, sizeof(SDVol));
    // WriteToSoundDevice(DN_SDVOLAUX2,   (B *)&volumeOff, sizeof(SDVol));
    return 0;
}

static void ReadFromSoundDevice(W dataNo, B *buffer, W size)
{
    W readBytes;
  
    W errorCode = rea_dev(soundDeviceID, dataNo, buffer, size, &readBytes, NULL);
    if (errorCode < 0 || readBytes < size) {
        if (errorCode < 0) {
            printf("rea_dev() returned error %d\n", errorCode);
        }
        else {
            printf("only %d bytes out of %d bytes were read", readBytes, size);
        }
        FATAL_ERROR("cannot read from the sound device");
    }
}

static void WriteToSoundDevice(W dataNo, B *buffer, W size)
{
    W writtenBytes;
    W errorCode;

    errorCode = wri_dev(soundDeviceID, dataNo, buffer, size, &writtenBytes, NULL);
    if (errorCode < 0 || writtenBytes < size) {
        if (errorCode < 0) {
            printf("wri_dev() returned error %d\n", errorCode);
        }
        else {
            printf("only %d bytes out of %d bytes were written", writtenBytes, size);
        }
        printf("dataNo: %d\n", dataNo);
        printf("size: %d\n", size);
        FATAL_ERROR("cannot write to the sound device");
    }
}

// ͤϥ顼:
//   0:   ｪλ
//   < 0: ݡȤƤʤ
static W SetSoundDeviceMode(int channels, unsigned int sampleRate)
{
    SDPcmInfo PCMInfo;
    static struct {
        W rate;
        W code;
    } sampleRateTable[] = {
        { 8000, 0},
        {11025, 1},
        {16000, 2},
        {22050, 3},
        {44100, 4},
        {48000, 5},
        {-1}
    };

    W i;
    W sampleRateCode;
    BOOL isSampleRateSupported = FALSE;

    // ɤư⡼ɤ򥵥ݡȤƤ뤫Ĵ٤
    ReadFromSoundDevice(DN_SDPCMINFO, (B *)&PCMInfo, sizeof(PCMInfo));
    sampleRateCode = -1;
    printf("sampleRate = %d\n", sampleRate);
    for (i = 0; sampleRateTable[i].rate >= 0; ++i) {
        if (sampleRateTable[i].rate == sampleRate) {
            sampleRateCode = sampleRateTable[i].code;
            break;
        }
    }
    if (sampleRateCode < 0) {
        return -1; // ̤ݡ
    }
    sprintf(debugstr, "sampleRateCode = %d\n", sampleRateCode);
    printdebug(debugfd, debugstr);
    sprintf(debugstr, "datafmt = 0x%08x\n", PCMInfo.spt[sampleRateCode].datafmt);
    printdebug(debugfd, debugstr);
    isSampleRateSupported =
         (PCMInfo.spt[sampleRateCode].datafmt & 0x0002)
         || (PCMInfo.spt[sampleRateCode].datafmt & 0x0004);
    sprintf(debugstr, "isSamplerateSupported = %d\n", isSampleRateSupported);
    printdebug(debugfd, debugstr);

    // ݡȤƤ⡼ɤ˽ѥ᡼ꤹ롣
    // ǡΥץ󥰥졼Ȥ48000MHzξ
    // 44100Mhz˥󥵥ץ󥰤롣
    if (isSampleRateSupported) {
        // ǡΥץ󥰼ȿϥɥǥХˤä
        // ݡȤƤ롣
        soundDeviceMode.sampling = sampleRateCode;
        if (PCMInfo.spt[sampleRateCode].datafmt & 0x0004) {
            soundDeviceMode.datafmt  = 2; // 16 bit linear (signed)
        }
        else {
            soundDeviceMode.datafmt  = 1; // 8 bit linear (unsigned)
        }
        if (PCMInfo.spt[sampleRateCode].splay) {
            soundDeviceMode.stereo = (Bool)1; // stereo
        }
        else if (PCMInfo.spt[sampleRateCode].mplay) {
            soundDeviceMode.stereo = (Bool)0; // mono
        }
        else {
            return -1; // ???
        }
    }
    else if (sampleRate == 48000
             && (PCMInfo.spt[4 /* 44100MHz */].datafmt & 0x0004)
             && PCMInfo.spt[4].splay) {
        // ץ󥰼ȿ48000MHzǽϥǥХ44100Mhzƥ쥪Ϥ
        // бƤˤΤߥ󥵥ץ󥰤Ԥ
        isDS48KOn = TRUE;
        InitializeDS48KConversionTable();
        soundDeviceMode.sampling = 4; // 44100MHz
        soundDeviceMode.datafmt  = 2; // 16 bit linear (signed);
        soundDeviceMode.stereo   = (Bool)1; // stereo
        sprintf(debugstr, "DS48KOriginalSamples is initialized to 0\n");
        printdebug(debugfd, debugstr);
        DS48KOriginalSamples = 0;
   }
   else {
      return -1; // ̤ݡ
   }
   soundDeviceMode.rsv = 0; // reserved
   sprintf(debugstr, "sampling = %d\n", (W)soundDeviceMode.sampling);
   printdebug(debugfd, debugstr);
   sprintf(debugstr, "datafmt  = %d\n", (W)soundDeviceMode.datafmt);
   printdebug(debugfd, debugstr);
   sprintf(debugstr, "stereo   = %d\n", (W)soundDeviceMode.stereo);
   printdebug(debugfd, debugstr);
   WriteToSoundDevice(DN_SDPCMMODE, (B *)&soundDeviceMode, sizeof(SDPcmMode));

   // ｪλ
   isSoundDeviceModeSet = TRUE;
   return 0;
}

// 48000MHz -> 44100MHz 󥵥ץѥ롼
// 48000MHzȷ䴰44100MHz˥󥵥ץ󥰤
//
// DS48KOriginalSampleBuffer*դˤʤäFLushDS48KOriginalSampleBuffer()
// ƤӽФ졢ºݤѴȤԤ롣

static void InitializeDS48KConversionTable()
{
    W originalIndex;
    W convertedIndex;

    DS48KWeightMax = DS48KConvertedSamplesMax;

    for (convertedIndex = 0;
         convertedIndex < DS48KConvertedSamplesMax;
         ++convertedIndex) {
        originalIndex =
           (convertedIndex * DS48KOriginalSamplesMax) / DS48KConvertedSamplesMax;
        if (originalIndex >= DS48KOriginalSamplesMax)
        originalIndex = DS48KOriginalSamplesMax - 1;
        DS48K1stOriginalSampleIndexTable[convertedIndex] = originalIndex;
        // ;꤬оۤɡ¦ΥץνŤդ礭ʤ
        DS48K1stOriginalSampleWeightTable[convertedIndex] = 
            DS48KConvertedSamplesMax
            - (convertedIndex * DS48KOriginalSamplesMax) % DS48KConvertedSamplesMax;
    }
}


// βMADOutput()ƤФ
// ˤƤΤϤ줬饤ؿ
static inline signed int Scale16(mad_fixed_t sample)
{
    // ʤǥȤäȷ䴰ꤹ
    // ɤΤ( minimad.cΤޤ

    // ޤ
    sample += (1L << (MAD_F_FRACBITS - 16));

    // å
    if (sample >= MAD_F_ONE) {
        sample = MAD_F_ONE - 1;
    }
    else if (sample < -MAD_F_ONE) {
        sample = -MAD_F_ONE;
    }
    // ̻Ҳ
    return sample >> (MAD_F_FRACBITS + 1 - 16);
}

static inline signed int Scale8(mad_fixed_t sample)
{
    signed int sample8  = (Scale16(sample) + 32768 + 127) >> 8;
    if (sample8 > 0xff) {
        sample8 = 0xff;
    }
    else if (sample8 < 0) {
        sample8 = 0x00;
    }
    return sample8;
}


static void FlushDS48KOriginalSampleBuffer()
{
    W originalIndex;
    W convertedIndex;
    W weight1, weight2;
    W convertedSample;
    W originalSample;
    W totalConvertedSamples = 0;

    for (convertedIndex = 0;
        convertedIndex < DS48KConvertedSamplesMax; ++convertedIndex) {
        originalIndex = DS48K1stOriginalSampleIndexTable[convertedIndex];
        if (originalIndex >= DS48KOriginalSamples - 1) {      
            // ǸΥץξѴϹԤʤ
            if (DS48KOriginalSamples - 1 < 0
                || DS48KOriginalSamples - 1 >= DS48KOriginalSamples) {
                FATAL_ERROR("array index out of bounds");
            }
            originalSample = DS48KOriginalSampleBufferLeft[DS48KOriginalSamples-1];
            PutByte((originalSample >> 0) & 0xff);
            PutByte((originalSample >> 8) & 0xff);
            if (DS48KOriginalSamples - 1 < 0
                || DS48KOriginalSamples - 1 >= DS48KOriginalSamples) {
                FATAL_ERROR("array index out of bounds");
            }
            originalSample = DS48KOriginalSampleBufferRight[DS48KOriginalSamples-1];
            PutByte((originalSample >> 0) & 0xff);
            PutByte((originalSample >> 8) & 0xff);
            break;
        }

        weight1 = DS48K1stOriginalSampleWeightTable[originalIndex];
        weight2 = DS48KWeightMax - weight1;
    
        // left
        convertedSample
            = (DS48KOriginalSampleBufferLeft[originalIndex]     + 32768) * weight1
              + (DS48KOriginalSampleBufferLeft[originalIndex + 1] + 32768) * weight2;
        convertedSample += DS48KWeightMax >> 1; // ͼθ
        convertedSample /= DS48KWeightMax; 
        convertedSample -= 32768;
        if (convertedSample > 32767) {
            convertedSample = 32767;
        }
        else if (convertedSample < -32768) {
            convertedSample = -32768;
        }
        PutByte((convertedSample >> 0) & 0xff);
        PutByte((convertedSample >> 8) & 0xff);

        // right
        convertedSample
            = (DS48KOriginalSampleBufferRight[originalIndex]     + 32768) * weight1
              + (DS48KOriginalSampleBufferRight[originalIndex + 1] + 32768) * weight2;
        convertedSample += DS48KWeightMax >> 1; // ͼθ
        convertedSample /= DS48KWeightMax; 
        convertedSample -= 32768;
        if (convertedSample > 32767) {
            convertedSample = 32767;
        }
        else if (convertedSample < -32768) {
            convertedSample = -32768;
        }
        PutByte((convertedSample >> 0) & 0xff);
        PutByte((convertedSample >> 8) & 0xff);

        ++totalConvertedSamples;
    }

    DS48KOriginalSamples = 0;
}

static int flush_first = 0;
static void FlushOutputBuffer()
{
    W errorCode;
    W PCMControl;

    if (outputBufferBytes <= 0) {
        return;
    }
    if (vstatus != VIDEO_PLAY) {
        outputBufferBytes = 0;
        return;
    }
//  if (decoderState == PREPARING_STATE) {
    if (flush_first == 0) {
        // ǽν񤭹
        // λǺ򳫻Ϥ
        // 0: ХåեƬ񤭹(ޤǤΥХåեƤϾõ)
        WriteToSoundDevice(0, outputBuffer, outputBufferBytes); 
        outputBufferBytes = 0;
        flush_first = 1;

        // 
        PCMControl = PCM_PLAY;
        WriteToSoundDevice(DN_SDPCMCTL, (B *)&PCMControl, sizeof(PCMControl));
    }
    else {
        // ɲý񤭹
        // ξ硢ߤޤäƤľ
        // ݡƤϲ⤷ʤ
        // ٥ȥե饰򥷥ƥ॰Хʥե饰ѿȤƻȤ
        // Υ٥ȥե饰ϥݡƤȤ˥ޡץ
        // ˤꥻåȤ롣
        // ե饰åȤƤʤ硢wai_flg()EC_NONE֤
        BOOL paused;
        ReadFromSoundDevice(DN_SDPCMCTL, (B *)&PCMControl, sizeof(PCMControl));
//        errorCode = wai_flg(pauseEventFlagID, 1, WF_AND | NOCLR, T_NOWAIT);
//        paused = (errorCode == EC_NONE);
//        if (!paused && PCMControl == PCM_STOP) {
        if (PCMControl == PCM_STOP) {
            PCMControl = PCM_PLAY;
            WriteToSoundDevice(DN_SDPCMCTL, (B *)&PCMControl, sizeof(PCMControl));
        }

        // ǥХνǤޤԤ
        // ȤŬޤưƤ褦ʤΤǤΤޤޤˤƤ
        while (GetAvailableBufferForSoundOutput() < OUTPUT_BUFFER_SIZE) {
//      if (decoderState == STOPPED_STATE) {
//        outputBufferBytes = 0;
//        return;
//      }
            wai_prc(10);
        }

        // ǥХ˽񤭹
        WriteToSoundDevice(1, outputBuffer, outputBufferBytes); 
        outputBufferBytes = 0;
    }
}

static W GetAvailableBufferForSoundOutput()
{
    W availableBuffer;
    W errorCode = wri_dev(soundDeviceID, 0, NULL, 0, &availableBuffer, NULL);

    if (errorCode < 0) {
        printf("wri_dev() returned error %d\n", errorCode);
        FATAL_ERROR("cannot obtain the size of available buffer");
    }
    return availableBuffer;
}

struct mad_decoder audiodecoder;

int openmpegaudio()
{
    if (soundDeviceID < 0) {
        return 0;
    }
    struct buffer buffer;

    closempegaudio();

    /* initialize our private message structure */
    int err, alen;
    UB *buf;

    // Хåեν
    outputBufferBytes = 0;
    isSoundDeviceModeSet = FALSE;
    isAudioInfoSent = FALSE;
    buffer.start = NULL;
    buffer.length = 0;
    mad_input_finish = 0;
    aoffset = 0;
    totalsamples = 0;
    flush_first = 0;

    /* configure input, output, and error functions */
    mad_decoder_init(&audiodecoder, &buffer,
		   input, 0 /* header */, 0 /* filter */, output,
		   error, 0 /* message */);
    /* start decoding */

    demux_init(1);

    return mad_decoder_run_init(&audiodecoder);
}

void closempegaudio() {
    // 󥵥ץѤΥХåեեå
    if (isDS48KOn && DS48KOriginalSamples > 0) {
        FlushDS48KOriginalSampleBuffer();
    }
      
    // ɥǥХѥХåեեå
    if (outputBufferBytes > 0) {
        FlushOutputBuffer();
    }
    mad_decoder_finish(&audiodecoder);
    if (prev_audio_buffer) {
        free(prev_audio_buffer);
        prev_audio_buffer = NULL;
    }
}

void stopaudioplay()
{
    W PCMControl;
    if (soundDeviceID < 0) {
        return;
    }
    
    PCMControl = PCM_STOP;
    WriteToSoundDevice(DN_SDPCMCTL, (B *)&PCMControl, sizeof(PCMControl));
}

int audioplay() 
{
    UW ctime;
    W wtime;
    int totaltime;
    if (samplerate == 0) {
        samplerate = 44100;
    }
    totaltime = totalsamples / samplerate * 1000;
    get_etm(&ctime);
    wtime = totaltime - (ctime - starttime);
    if (wtime >= 30 && !nowait) {
//sprintf(debugstr, "wtime %d\n",wtime);
//printdebug(debugfd, debugstr);
        slp_tsk(wtime);
    }
    return mad_decoder_run_sync(&audiodecoder);
//sprintf(debugstr, "aplay2 end\n");
//printdebug(debugfd, debugstr);
}
