#include "mplayer.h"

static int buffer_size = 4096;

static W	mpeg2AudioStreamID = 0xc0;
static W        mpeg2VideoStreamID = 0xe0;

#define DEMUX_HEADER 0
#define DEMUX_DATA 1
#define DEMUX_SKIP 2

#define NEEDBYTES(x) do { int missing; missing = (x) - bytes; if (missing > 0) { if (header == head_buf) { if (missing <= end - buf) { memcpy (header + bytes, buf, missing); buf += missing; bytes = (x); } else { memcpy (header + bytes, buf, end - buf); state_bytes = bytes + end - buf; if (bufend) { if (mode == DEMUX_VIDEO_MODE) { decode_mpeg2 (buforig, bufend, mpeg2dec); RESTORE_STATE ; return bufend - buforig; } else { RESTORE_STATE ; return bufend - buforig; } } RESTORE_STATE ; return 0; } } else { memcpy (head_buf, header, bytes); state = DEMUX_HEADER; state_bytes = bytes; if (bufend) { if (mode == DEMUX_VIDEO_MODE) { decode_mpeg2 (buforig, bufend, mpeg2dec); RESTORE_STATE ; return bufend - buforig; } else { RESTORE_STATE ; return bufend - buforig; } } RESTORE_STATE ; return 0; } } } while (0)
//#define NEEDBYTES(x) do { int missing; missing = (x) - bytes; if (missing > 0) { if (header == head_buf) { if (missing <= end - buf) { memcpy (header + bytes, buf, missing); buf += missing; bytes = (x); } else { memcpy (header + bytes, buf, end - buf); state_bytes = bytes + end - buf; if (bufend && 0) { if (mode == DEMUX_VIDEO_MODE) { decode_mpeg2 (buforig, bufend, mpeg2dec); RESTORE_STATE ; return bufend - buforig; } else { RESTORE_STATE ; return bufend - buforig; } } RESTORE_STATE ; return 0; } } else { memcpy (head_buf, header, bytes); state = DEMUX_HEADER; state_bytes = bytes; if (bufend && 0) { if (mode == DEMUX_VIDEO_MODE) { decode_mpeg2 (buforig, bufend, mpeg2dec); RESTORE_STATE ; return bufend - buforig; } else { RESTORE_STATE ; return bufend - buforig; } } RESTORE_STATE ; return 0; } } } while (0)


#if 0
#define NEEDBYTES(x) 
do { 
  int missing;
  missing = (x) - bytes;
  if (missing > 0) { 
    if (header == head_buf) {
      if (missing <= end - buf) { 
        memcpy (header + bytes, buf, missing);
        buf += missing; bytes = (x);
      } 
      else { 
        memcpy (header + bytes, buf, end - buf); 
        state_bytes = bytes + end - buf;
        if (bufend) { 
          if (mode == DEMUX_VIDEO_MODE) { 
            decode_mpeg2 (buforig, bufend, mpeg2dec);
            RESTORE_STATE ; 
            return bufend - buforig; 
          } 
          else { 
            RESTORE_STATE ;
            return bufend - buforig;
          }
        }
        RESTORE_STATE ;
        return 0;
      }
    }
    else {
      memcpy (head_buf, header, bytes);
      state = DEMUX_HEADER;
      state_bytes = bytes; 
      if (bufend) {
        if (mode == DEMUX_VIDEO_MODE) {
          decode_mpeg2 (buforig, bufend, mpeg2dec); 
          RESTORE_STATE ;
          return bufend - buforig; 
        }
        else {
          RESTORE_STATE ;
          return bufend - buforig;
        }
     }
     RESTORE_STATE ; 
     return 0;
   }
 }
} while (0)
#endif


#define DONEBYTES(x) do { if (header != head_buf) buf = header + (x); } while (0)


#define DEMUX_PAYLOAD_START 1

static int video_state = DEMUX_SKIP;
static int video_state_bytes = 0;
static W video_streamID = mpeg2VideoStreamID;

static int audio_state = DEMUX_SKIP;
static int audio_state_bytes = 0;
static W audio_streamID = mpeg2VideoStreamID;

//DEMUXӥǥǥξ
void demux_init(int mode)
{
    if (mode == 0 || mode == 2) {
        video_state = DEMUX_SKIP;
        video_state_bytes = 0;
        video_streamID = mpeg2VideoStreamID;
    }

    if (mode == 1 || mode == 2) {
        audio_state = DEMUX_SKIP;
        audio_state_bytes = 0;
        audio_streamID = mpeg2VideoStreamID;
    }
}

int demux2 (uint8_t * buf, uint8_t * end, int flags, mpeg2dec_t *mpeg2dec, int mode, int * finish)
{
    static int mpeg1_skip_table[16] = {
	0, 0, 4, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
    };

#define DEMUX_HEADER 0
#define DEMUX_DATA 1
#define DEMUX_SKIP 2
    static uint8_t video_head_buf[264];
    static uint8_t audio_head_buf[264];

#define RESTORE_STATE { if (mode == DEMUX_VIDEO_MODE) { video_state = state; video_state_bytes = state_bytes; video_streamID = streamID; } else { audio_state = state; audio_state_bytes = state_bytes; audio_streamID = streamID; } }

    static int demux_pid = 0;
//    static int demux_track = 0xe0;

    int state;
    int state_bytes;
    uint8_t *head_buf;


    static W streamID = mpeg2VideoStreamID;

    if (finish) {
        *finish = 0;
    }
    if (mode == DEMUX_VIDEO_MODE) {
        state = video_state;
        state_bytes = video_state_bytes;
        head_buf = video_head_buf;
        streamID = video_streamID;
    }
    else {
        state = audio_state;
        state_bytes = audio_state_bytes;
        head_buf = audio_head_buf;
        streamID = audio_streamID;
    }

    uint8_t * header;
    int bytes;
    int len;

    uint8_t * buforig, *bufend;
    buforig = buf;
    bufend = NULL;

    if (flags & DEMUX_PAYLOAD_START)
	goto payload_start;
    switch (state) {
    case DEMUX_HEADER:
	if (state_bytes > 0) {
	    header = head_buf;
	    bytes = state_bytes;
	    goto continue_header;
	}
	break;
    case DEMUX_DATA:
	if (demux_pid || (state_bytes > end - buf)) {
            if (streamID == mpeg2VideoStreamID && mode == DEMUX_VIDEO_MODE) {
                decode_mpeg2 (buf, end, mpeg2dec);
  	        state_bytes -= end - buf;
	        RESTORE_STATE
	        return end - buf;
            }
            else if (streamID == mpeg2AudioStreamID && mode == DEMUX_AUDIO_MODE) {
                memcpy(buforig, buf, end - buf);
  	        state_bytes -= end - buf;
	        RESTORE_STATE
	        return end - buf;
            }
	    state_bytes -= end - buf;
	    RESTORE_STATE
	    return 0;
	}
//	decode_mpeg2 (buf, buf + state_bytes, mpeg2dec);
        if ((streamID == mpeg2VideoStreamID && mode == DEMUX_VIDEO_MODE) ||
            (streamID == mpeg2AudioStreamID && mode == DEMUX_AUDIO_MODE)) {
            if (buf != buforig) {
                memcpy(buforig, buf, state_bytes);
            }
            bufend = buforig + state_bytes;
        }
	buf += state_bytes;
	break;
    case DEMUX_SKIP:
	if (demux_pid || (state_bytes > end - buf)) {
	    state_bytes -= end - buf;
	    RESTORE_STATE
	    return 0;
	}
	buf += state_bytes;
	break;
    }

    while (1) {
	if (demux_pid) {
	    state = DEMUX_SKIP;
	    RESTORE_STATE
	    return 0;
	}
    payload_start:
	header = buf;
	bytes = end - buf;
    continue_header:
	NEEDBYTES (4);
	if (header[0] || header[1] || (header[2] != 1)) {
	    if (demux_pid) {
		state = DEMUX_SKIP;
  	        RESTORE_STATE
		return 0;
	    } else if (header != head_buf) {
		buf++;
		goto payload_start;
	    } else {
		header[0] = header[1];
		header[1] = header[2];
		header[2] = header[3];
		bytes = 3;
		goto continue_header;
	    }
	}
	if (demux_pid) {
	    if ((header[3] >= 0xe0) && (header[3] <= 0xef))
		goto pes;
	    //fprintf (stderr, "bad stream id %x\n", header[3]);
	    //exit (1);
	}
	switch (header[3]) {
	case 0xb9:	/* program end code */
	    /* DONEBYTES (4); */
	    /* break;         */
            if (finish) {
                *finish = 1;
            }
//sprintf(debugstr, "end code %d %d %d\n", bufend, buforig, bufend - buforig);
//printdebug(debugfd, debugstr);
            if (bufend) {
                if (mode == DEMUX_VIDEO_MODE) {
                    decode_mpeg2 (buforig, bufend, mpeg2dec);
                }
  	        RESTORE_STATE
	        return bufend - buforig;
            }
	    RESTORE_STATE
	    return 0;
	case 0xba:	/* pack header */
	    NEEDBYTES (5);
	    if ((header[4] & 0xc0) == 0x40) {	/* mpeg2 */
		NEEDBYTES (14);
		len = 14 + (header[13] & 7);
		NEEDBYTES (len);
		DONEBYTES (len);
		/* header points to the mpeg2 pack header */
	    } else if ((header[4] & 0xf0) == 0x20) {	/* mpeg1 */
		NEEDBYTES (12);
		DONEBYTES (12);
		/* header points to the mpeg1 pack header */
	    } else {
		//fprintf (stderr, "weird pack header\n");
                sprintf(debugstr, "weird pack header\n");
                printdebug(debugfd, debugstr);
		DONEBYTES (5);
	    }
	    break;
	default:
//	    if (header[3] == demux_track) {
//            if ((mode == DEMUX_VIDEO_MODE && header[3] == mpeg2VideoStreamID) ||
//                (mode == DEMUX_AUDIO_MODE && header[3] == mpeg2AudioStreamID)) {
            if (header[3] == mpeg2VideoStreamID || header[3] == mpeg2AudioStreamID) {
		streamID = header[3];
	    pes:
		NEEDBYTES (7);
		if ((header[6] & 0xc0) == 0x80) {	/* mpeg2 */
		    NEEDBYTES (9);
		    len = 9 + header[8];
		    NEEDBYTES (len);
		    /* header points to the mpeg2 pes header */
		    if (header[7] & 0x80) {
			uint32_t pts, dts;

			pts = (((header[9] >> 1) << 30) |
			       (header[10] << 22) | ((header[11] >> 1) << 15) |
			       (header[12] << 7) | (header[13] >> 1));
                        if (mode == DEMUX_VIDEO_MODE && streamID == mpeg2VideoStreamID) {
  			    dts = (!(header[7] & 0x40) ? pts :
			       (((header[14] >> 1) << 30) |
				(header[15] << 22) |
				((header[16] >> 1) << 15) |
				(header[17] << 7) | (header[18] >> 1)));
			    mpeg2_tag_picture (mpeg2dec, pts, dts);
                        }
                        else if (mode == DEMUX_AUDIO_MODE && streamID == mpeg2AudioStreamID) {
//                           sprintf(debugstr, "mpeg2AudioFirstPTS %d\n", pts);
//                           printdebug(debugfd, debugstr);
                        }
		    }
		} else {	/* mpeg1 */
		    int len_skip;
		    uint8_t * ptsbuf;

		    len = 7;
		    while (header[len - 1] == 0xff) {
			len++;
			NEEDBYTES (len);
			if (len > 23) {
			    //fprintf (stderr, "too much stuffing\n");
                            sprintf(debugstr, "too much stuffing\n");
                            printdebug(debugfd, debugstr);
			    break;
			}
		    }
		    if ((header[len - 1] & 0xc0) == 0x40) {
			len += 2;
			NEEDBYTES (len);
		    }
		    len_skip = len;
		    len += mpeg1_skip_table[header[len - 1] >> 4];
		    NEEDBYTES (len);
		    /* header points to the mpeg1 pes header */
		    ptsbuf = header + len_skip;
// for audio		    if ((ptsbuf[-1] & 0xe0) == 0x20) {
		    if (ptsbuf[-1] & 0x20) {
			uint32_t pts, dts;

			pts = (((ptsbuf[-1] >> 1) << 30) |
			       (ptsbuf[0] << 22) | ((ptsbuf[1] >> 1) << 15) |
			       (ptsbuf[2] << 7) | (ptsbuf[3] >> 1));
                        if (mode == DEMUX_VIDEO_MODE && streamID == mpeg2VideoStreamID) {
  			    dts = (((ptsbuf[-1] & 0xf0) != 0x30) ? pts :
			       (((ptsbuf[4] >> 1) << 30) |
				(ptsbuf[5] << 22) | ((ptsbuf[6] >> 1) << 15) |
				(ptsbuf[7] << 7) | (ptsbuf[18] >> 1)));
			    mpeg2_tag_picture (mpeg2dec, pts, dts);
                        }
                        else if (mode == DEMUX_AUDIO_MODE && streamID == mpeg2AudioStreamID) {
//                           sprintf(debugstr, "mpeg1AudioFirstPTS %d\n", pts);
//                           printdebug(debugfd, debugstr);
                        }
		    }
		}
		DONEBYTES (len);
		bytes = 6 + (header[4] << 8) + header[5] - len;
		if (demux_pid || (bytes > end - buf)) {
                    int retvalue;
                    if (bufend) {
                        if (mode == DEMUX_VIDEO_MODE) {
                            if (streamID == mpeg2VideoStreamID) {
                                memcpy(bufend, buf, end - buf);
                                bufend += end - buf;
                            }
 	                    decode_mpeg2 (buforig, bufend, mpeg2dec);
                            retvalue = bufend - buforig;
                        }
                        else if (mode == DEMUX_AUDIO_MODE) {
                            if (streamID == mpeg2AudioStreamID) {
                                memcpy(bufend, buf, end - buf);
                                bufend += end - buf;
                            }
                            retvalue = bufend - buforig;
                        }
                    }
                    else {
                        if (mode == DEMUX_VIDEO_MODE) {
                            if (streamID == mpeg2VideoStreamID) {
     		                decode_mpeg2 (buf, end, mpeg2dec);
                                retvalue = end - buf;
                            }
                            else {
                                retvalue = 0;
                            }
                        }
                        else if (mode == DEMUX_AUDIO_MODE) {
                            if (streamID == mpeg2AudioStreamID) {
                                memcpy(buforig, buf, end - buf);
                                retvalue = end - buf;
                            }
                            else {
                                retvalue = 0;
                            }
                        }
                    }
		    state = DEMUX_DATA;
		    state_bytes = bytes - (end - buf);
		    RESTORE_STATE
		    return retvalue;
		} else if (bytes > 0) {
		    //decode_mpeg2 (buf, buf + bytes, mpeg2dec);
                    if (bufend) {
                        if ((mode == DEMUX_VIDEO_MODE && streamID == mpeg2VideoStreamID) ||
			    (mode == DEMUX_AUDIO_MODE && streamID == mpeg2AudioStreamID)) {
                            memcpy(bufend, buf, bytes);
                            bufend += bytes;
                        }
                    }
                    else {
                        if (buf != buforig) {
                            if ((mode == DEMUX_VIDEO_MODE && streamID == mpeg2VideoStreamID) ||
    			        (mode == DEMUX_AUDIO_MODE && streamID == mpeg2AudioStreamID)) {
                                memcpy(buforig, buf, bytes);
                                bufend = buforig + bytes;
                            }
                        }
                        else {
                            if ((mode == DEMUX_VIDEO_MODE && streamID == mpeg2VideoStreamID) ||
    			        (mode == DEMUX_AUDIO_MODE && streamID == mpeg2AudioStreamID)) {
                                bufend = buforig + bytes;
                            }
                        }
                    }
		    buf += bytes;
		}
	    } else if (header[3] < 0xb9) {
		//fprintf (stderr,
		//	 "looks like a video stream, not system stream\n");
                sprintf(debugstr, "looks like a video stream, not system stream\n");
                printdebug(debugfd, debugstr);
		DONEBYTES (4);
	    } else {
		NEEDBYTES (6);
		DONEBYTES (6);
		bytes = (header[4] << 8) + header[5];
		if (bytes > end - buf) {
		    state = DEMUX_SKIP;
		    state_bytes = bytes - (end - buf);
                    if (bufend) {
                        if (mode == DEMUX_VIDEO_MODE) {
      		            decode_mpeg2 (buforig, bufend, mpeg2dec);
    		            RESTORE_STATE
		            return bufend - buforig;
                        }
                        else if (mode == DEMUX_AUDIO_MODE) {
    		            RESTORE_STATE
		            return bufend - buforig;
                        }
                    }
   	            RESTORE_STATE
		    return 0;
		}
		buf += bytes;
	    }
	}
    }
}

void decode_mpeg2 (uint8_t * current, uint8_t * end, mpeg2dec_t *mpeg2dec)
{
//static int c = 0;
//c += end - current;
//sprintf(debugstr, "output length %d\n", c);
//printdebug(debugfd, debugstr);
#if 1
    mpeg2_buffer (mpeg2dec, current, end);
//drawframe();
#else

    const mpeg2_info_t * info;
    mpeg2_state_t state;

    mpeg2_buffer (mpeg2dec, current, end);

    info = mpeg2_info (mpeg2dec);
    while (1) {
	state = mpeg2_parse (mpeg2dec);
	switch (state) {
	case STATE_BUFFER:
	    return;
	case STATE_SEQUENCE:
	    /* might set nb fbuf, convert format, stride */
	    /* might set fbufs */
	    mpeg2_convert (mpeg2dec, mpeg2convert_rgb32, NULL);
	 //   mpeg2_skip (mpeg2dec, 0);
	    break;
	case STATE_PICTURE:
	    /* might skip */
	    /* might set fbuf */
	    break;
	case STATE_SLICE:
	case STATE_END:
	case STATE_INVALID_END:
	    /* draw current picture */
	    /* might free frame buffer */
	    if (info->display_fbuf) {
                    UB *tmpptr;
                    tmpptr = bmp.baseaddr[0];
                    bmp.baseaddr[0] = (UB *)info->display_fbuf->buf[0];
                    grst_bmp(mygid, &visrect, &bmp, &(bmp.bounds), NULL, G_STORE);
                    bmp.baseaddr[0] = tmpptr;
            }
	    break;
	default:
	    break;
	}
    }
#endif
}


void ps_loop (mpeg2dec_t *mpeg2dec)
{
    uint8_t * buffer = (uint8_t *) malloc (buffer_size);
    uint8_t * end;
    W size, tmpsize;

    if (buffer == NULL)
	exit (1);
    do {
//	end = buffer + fread (buffer, 1, buffer_size, in_file);
        rea_rec(mpegfd, foffset, (B *)buffer, buffer_size, &tmpsize, NULL);
        size = tmpsize;
        if (size > buffer_size) {
            size = buffer_size;
        }
        end = buffer + size;
	if (demux2 (buffer, end, 0, mpeg2dec, DEMUX_VIDEO_MODE, NULL))
	    break;	/* hit program_end_code */
    } while (end == buffer + buffer_size);
    free (buffer);
}

