#include "tcconv.h"

VOID astotc(B *asc, TC *tcode)
{
    B *as;
    TC *tc;

    as = asc;
    tc= tcode;
    while ((*as != 0) && (as - asc < 64)) { 
	*tc++ = _asctotc[*as++];
    }
    *tc = TNULL;
}

VOID numtotc(W num, TC *tcode)
{
    *tcode       = TK_0 + (num / 10);
    *(tcode + 1) = TK_0 + (num % 10);
}

W tctoasc(TC *tname, B *aname, W num)
{
    TC *tpt;
    B  *apt;
    W  i;
    
    i = 0;
    tpt = tname;
    apt = aname;
    while ((*tpt != TNULL) && (tpt - tname < num)) {
	if ((*tpt >= TK_A) && (*tpt <= TK_Z)) {
	    *apt = 'A' + *tpt - TK_A;
	}
	else if ((*tpt >= TK_a) && (*tpt <= TK_z)) {
	    *apt = 'a' + *tpt - TK_a;
	}
	else if ((*tpt >= TK_0) && (*tpt <= TK_9)) {
	    *apt = '0' + *tpt - TK_0;
	}
	else {
	    switch (*tpt) {
	    case TK_SP0:
	    case TK_SP1:
	    case TK_KSP:
		*apt = ' ';
		break;
	    case TK_EXCL:
		*apt = '!';
		break;
	    case TK_RQOT:
		*apt = '`';
		break;
	    case TK_DQOT:
		*apt = '"';
		break;
	    case TK_SHRP:
		*apt = '#';
		break;
	    case TK_DLLR:
		*apt = '$';
		break;
	    case TK_PCNT:
		*apt = '%';
		break;
	    case TK_AND:
		*apt = '&';
		break;
	    case TK_SQOT:
		*apt = '\'';
		break;
	    case TK_LPAR:
		*apt = '(';
		break;
	    case TK_RPAR:
		*apt = ')';
		break;
	    case TK_ASTR:
		*apt = '*';
		break;
	    case TK_PLUS:
		*apt = '+';
		break;
	    case TK_CMMA:
		*apt = ',';
		break;
	    case TK_MINS:
		*apt = '-';
		break;
	    case TK_PROD:
		*apt = '.';
		break;
	    case TK_SLSH:
		*apt = '/';
		break;
	    case TK_COLN:
		*apt = ':';
		break;
	    case TK_SCLN:
		*apt = ';';
		break;
	    case TK_LSTN:
		*apt = '<';
		break;
	    case TK_EQAL:
		*apt = '=';
		break;
	    case TK_GTTN:
		*apt = '>';
		break;
	    case TK_QSTN:
		*apt = '?';
		break;
	    case TK_ATMK:
		*apt = '@';
		break;
	    case TK_LABR:
		*apt = '[';
		break;
	    case TK_BSLH:
		*apt = '\\';
		break;
	    case TK_RABR:
		*apt = ']';
		break;
	    case TK_EXOR:
		*apt = '^';
		break;
	    case TK_USCR:
		*apt = '_';
		break;
	    case TK_LCBR:
		*apt = '{';
		break;
	    case TK_OR:
		*apt = '|';
		break;
	    case TK_RCBR:
		*apt = '}';
		break;
	    case TK_TILD:
		*apt = '~';
		break;
	    default:
		*apt = '-';
		i = 1;
		break;
	    }
	}
	tpt++;
	apt++;
    }
    *apt = 0;
    return i;
}

